//+------------------------------------------------------------------+
//|                                                  test pivots.mq4 |
//+------------------------------------------------------------------+

extern int CountDays    =  5;
extern int NY_CloseHour =  1;
extern int DaysNumber1  =  5;
extern int DaysNumber2  = 10;
extern int DaysNumber3  = 20;
extern int DayShift     =  0;
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int maxDays = MathMax(MathMax(DaysNumber1,DaysNumber2),DaysNumber3);
   double   range[];    ArrayResize(range   ,CountDays+maxDays+1);
   double   ny_close[]; ArrayResize(ny_close,CountDays+maxDays+1);
   double   ny_time[];  ArrayResize(ny_time ,CountDays+maxDays+1);
   double   ny_shift[]; ArrayResize(ny_shift,CountDays+maxDays+1);

   //
   //
   //
   //
   //

      for (int i=0; i <= CountDays+maxDays; i++)
      {
         ny_time[i]  = iTime(NULL,PERIOD_D1,i) + (NY_CloseHour-Period()/60.0)*3600;
         ny_shift[i] = iBarShift(NULL,0,ny_time[i]);
         ny_close[i] = iClose(NULL,0,ny_shift[i]);        
      }
      for (i=0; i <= CountDays+maxDays-1; i++)
      {
         int length   = ny_shift[i+1]-ny_shift[i];
             range[i] = High[iHighest(NULL,0,MODE_HIGH,length,ny_shift[i])]-Low [iLowest(NULL,0,MODE_LOW ,length,ny_shift[i])];
      }

   //
   //
   //     
   //
   //

      double sumR5  = 0; for(i=0;i<DaysNumber1;i++) sumR5  += range[i+DayShift];
      double sumR10 = 0; for(i=0;i<DaysNumber2;i++) sumR10 += range[i+DayShift];
      double sumR20 = 0; for(i=0;i<DaysNumber3;i++) sumR20 += range[i+DayShift];
   
      double aR1   = NormalizeDouble(range[DayShift]   ,Digits); 
      double R5    = NormalizeDouble(sumR5/DaysNumber1 ,Digits);
      double R10   = NormalizeDouble(sumR10/DaysNumber2,Digits);
      double R20   = NormalizeDouble(sumR20/DaysNumber3,Digits);
      double Ravg  = NormalizeDouble((aR1+R5+R10+R20)/4,Digits);  

      double P  = ny_close[DayShift];
      double R1 = NormalizeDouble(P + 0.25*Ravg,Digits);
      double R2 = NormalizeDouble(P + 0.50*Ravg,Digits);
      double R3 = NormalizeDouble(P + 0.75*Ravg,Digits);
      double R4 = P + Ravg;

      double S1 = NormalizeDouble(P - 0.25*Ravg,Digits);
      double S2 = NormalizeDouble(P - 0.50*Ravg,Digits);
      double S3 = NormalizeDouble(P - 0.75*Ravg,Digits);
      double S4 = P - Ravg;

   //
   //
   //
   //
   //
   
   Comment("P    ",DoubleToStr(P,Digits),"\n",
           "R1   ",DoubleToStr(R1,Digits),"\n",
           "R2   ",DoubleToStr(R2,Digits),"\n",
           "R3   ",DoubleToStr(R3,Digits),"\n",
           "R4   ",DoubleToStr(R4,Digits),"\n",
           "S1   ",DoubleToStr(S1,Digits),"\n",
           "S2   ",DoubleToStr(S2,Digits),"\n",
           "S3   ",DoubleToStr(S3,Digits),"\n",
           "S4   ",DoubleToStr(S4,Digits));
}